import sys #line:1
import time #line:2
import threading #line:3
from pymysql import cursors #line:5
from pymysql .connections import Connection #line:6
from .import idec #line:8
from .import idict #line:9
__default__ :Connection #line:11
__lock__ =threading .Lock ()#line:12
@idec .TryExcept (Exception ,mark ='InitMySQL')#line:15
@idec .Retry ('InitMySQL',count =10 ,cycle =10 )#line:16
def __init__ (OOOO00OO00OO00OO0 :dict ):#line:17
    return Connection (**OOOO00OO00OO00OO0 )#line:18
def sql (O0O00O0OOOO0O0OOO :str ,*,one :bool =False ,dtype =dict ,conn :Connection =None ):#line:21
    conn =conn or __default__ #line:22
    conn .ping (reconnect =True )#line:23
    O00OOOOOOOO0O0000 =conn .cursor (Transaction .dtypes [dtype ])#line:25
    with __lock__ :#line:27
        O0OOOOOOO00OOO000 :int =O00OOOOOOOO0O0000 .execute (O0O00O0OOOO0O0OOO )#line:28
        conn .commit ()#line:29
    if O0O00O0OOOO0O0OOO .lstrip ()[:6 ].upper ()in ['INSERT','UPDATE','DELETE']:#line:31
        return O0OOOOOOO00OOO000 #line:32
    O0O00OOOOOO0OO00O =O00OOOOOOOO0O0000 .fetchall ()#line:34
    if dtype is dict :#line:36
        O0O00OOOOOO0OO00O =Transaction .upgrade_dtype (O0O00OOOOOO0OO00O )#line:37
    O00OOOOOOOO0O0000 .close ()#line:39
    return O0O00OOOOOO0OO00O [0 ]if one else O0O00OOOOOO0OO00O #line:41
class Transaction :#line:44
    dtypes ={tuple :cursors .Cursor ,dict :cursors .DictCursor }#line:48
    def __init__ (OO000OOOOO0O0O000 ,dtype =dict ,*,conn :Connection =None ):#line:50
        OO000OOOOO0O0O000 .conn =conn or __default__ #line:51
        conn .ping (reconnect =True )#line:52
        OO000OOOOO0O0O000 .cur =OO000OOOOO0O0O000 .conn .cursor (OO000OOOOO0O0O000 .dtypes [dtype ])#line:53
        OO000OOOOO0O0O000 .dtype =dtype #line:54
    def __call__ (OOOO0000OO00OO0O0 ,O0O00O00O0O000000 :str )->int :#line:56
        return OOOO0000OO00OO0O0 .cur .execute (O0O00O00O0O000000 )#line:57
    def __enter__ (O0O00OOO00O0OOOOO ):#line:59
        O0O00OOO00O0OOOOO .__lock__ .acquire ()#line:60
        return O0O00OOO00O0OOOOO #line:61
    def __exit__ (OOO0O0O00OO00OO0O ,OOOOOOO0000O0OO00 ,OO0OO00O00OO00O0O ,OO0O0O000O0OO0000 ):#line:63
        if OOOOOOO0000O0OO00 or OO0OO00O00OO00O0O or OO0O0O000O0OO0000 :#line:64
            OOO0O0O00OO00OO0O .conn .rollback ()#line:65
        OOO0O0O00OO00OO0O .conn .commit ()#line:66
        OOO0O0O00OO00OO0O .__lock__ .release ()#line:67
        OOO0O0O00OO00OO0O .cur .close ()#line:68
    def __getattribute__ (OO00O0O0O00000O00 ,OOOO00O0000O00000 ):#line:70
        try :#line:71
            OOOO0O00OOO00O000 =super ().__getattribute__ (OOOO00O0000O00000 )#line:72
        except AttributeError :#line:73
            OOOO0O00OOO00O000 =getattr (OO00O0O0O00000O00 .cur ,OOOO00O0000O00000 )#line:74
        return OOOO0O00OOO00O000 #line:76
    def __invert__ (O0O0000O0O0O000O0 ):#line:78
        return O0O0000O0O0O000O0 .fetchone #line:79
    @staticmethod #line:81
    def upgrade_dtype (data :list =None )->list :#line:82
        ""#line:83
        return list (map (lambda O00OOOO000O00O00O :idict (**O00OOOO000O00O00O ),data ))#line:84
    @property #line:86
    def fetchone (O0OOOOOOO0O00OOOO ):#line:87
        O00OO0OO00O0O000O =O0OOOOOOO0O00OOOO .cur .fetchone ()#line:88
        if O0OOOOOOO0O00OOOO .dtype is tuple :#line:90
            return O00OO0OO00O0O000O #line:91
        return idict (**O00OO0OO00O0O000O )#line:93
    @property #line:95
    def fetchall (O0O000OOOO0O0OOOO ):#line:96
        O00O0OO00O0O0O0O0 =O0O000OOOO0O0OOOO .cur .fetchall ()#line:97
        if O0O000OOOO0O0OOOO .dtype is tuple :#line:99
            return O00O0OO00O0O0O0O0 #line:100
        return O0O000OOOO0O0OOOO .upgrade_dtype (O00O0OO00O0O0O0O0 )#line:102
    @property #line:104
    def last_insert_id (O0O000OO0OO00O0O0 )->int :#line:105
        ""#line:109
        O0O000OO0OO00O0O0 ('SELECT LAST_INSERT_ID()')#line:110
        if O0O000OO0OO00O0O0 .dtype is tuple :#line:112
            return O0O000OO0OO00O0O0 .fetchone [0 ]#line:113
        return O0O000OO0OO00O0O0 .fetchone ['LAST_INSERT_ID()']#line:115
def __health_examination__ (cycle :int =60 *10 ):#line:118
    ""#line:122
    def __ (conns :'Not param'=[]):#line:124
        for O00OO0O0O00O00000 in sys .modules [__name__ ].__dir__ ():#line:125
            OOO00OO000OO00000 =getattr (sys .modules [__name__ ],O00OO0O0O00O00000 )#line:126
            if O00OO0O0O00O00000 !='__default__'and isinstance (OOO00OO000OO00000 ,Connection ):#line:127
                conns .append (OOO00OO000OO00000 )#line:128
        while True :#line:130
            time .sleep (cycle )#line:131
            for OOOO00OO000O0OO00 in conns :#line:132
                OOOO00OO000O0OO00 .ping (reconnect =True )#line:133
    threading .Thread (target =__ ,name ='PingMySQL',daemon =True ).start ()#line:135
