import abc #line:1
import time #line:2
import functools #line:3
import isddc as i #line:4
from .import itime #line:6
from .import ibase #line:7
from .import isddc_log as ilog #line:8
class BaseDecorator (metaclass =abc .ABCMeta ):#line:11
    def __call__ (O0O0OO0O000O0OOO0 ,OOO0OO0O0OOO0OOOO ):#line:13
        @functools .wraps (OOO0OO0O0OOO0OOOO )#line:14
        def O0OOO00O00OOO000O (*O0O000O0OO0OOO0O0 ,**O00OOOOO0OOO0O000 ):#line:15
            return O0O0OO0O000O0OOO0 .core (OOO0OO0O0OOO0OOOO ,*O0O000O0OO0OOO0O0 ,**O00OOOOO0OOO0O000 )#line:16
        return O0OOO00O00OOO000O #line:17
    @abc .abstractmethod #line:19
    def core (OO0O0OOOOOOOOOO0O ,OOOO000OOO00000O0 ,*O0O0O0O0OOO0OOO0O ,**O0OO00OOO0O000OO0 ):#line:20
        ...#line:21
class TryExcept (BaseDecorator ):#line:24
    def __init__ (O0OOO0OOO0OO00O00 ,exc_type :type or tuple =Exception ,*,mark :str =None ,ignore :bool =False ,exc_return =None ,exc_callback =None ):#line:34
        O0OOO0OOO0OO00O00 .mark =mark #line:35
        O0OOO0OOO0OO00O00 .ignore =ignore #line:36
        O0OOO0OOO0OO00O00 .exc_type =exc_type #line:37
        O0OOO0OOO0OO00O00 .exc_return =exc_return #line:38
        O0OOO0OOO0OO00O00 .exc_callback =exc_callback #line:39
    def core (OOO00OOOO0OOO0OOO ,O00OOO0OO0OOOOOOO ,*O00O00OO0O0000OOO ,**O0O0OO0000O0O0OOO ):#line:41
        try :#line:42
            return O00OOO0OO0OOOOOOO (*O00O00OO0O0000OOO ,**O0O0OO0000O0O0OOO )#line:43
        except OOO00OOOO0OOO0OOO .exc_type as O0000O00O00OOO0O0 :#line:44
            if OOO00OOOO0OOO0OOO .exc_callback :#line:45
                return OOO00OOOO0OOO0OOO .exc_callback (*O00O00OO0O0000OOO ,**O0O0OO0000O0O0OOO )#line:46
            if not OOO00OOOO0OOO0OOO .ignore :#line:48
                try :#line:49
                    OOO00OOOO0OOO0OOO .exception_handler (O00OOO0OO0OOOOOOO .__name__ ,O0000O00O00OOO0O0 )#line:50
                except Exception as O0000O00O00OOO0O0 :#line:51
                    ilog .simple .error (f'[{itime.Now.str}] TryExceptError: {O0000O00O00OOO0O0}')#line:52
        return OOO00OOOO0OOO0OOO .exc_return #line:54
    def exception_handler (O00OO0O0OOOO00OOO ,OOO00O00OO0O00000 :str ,O00OO00O00000O00O :Exception ):#line:56
        OOOO000O000O00000 :str =O00OO0O0OOOO00OOO .mark or i .hump (OOO00O00OO0O00000 )#line:57
        OO0O000OO0OO0O0OO :str =type (O00OO00O00000O00O ).__name__ #line:58
        ilog .simple .error (f'{OOOO000O000O00000}.{OO0O000OO0OO0O0OO}: {str(O00OO00O00000O00O)}')#line:59
class Retry (BaseDecorator ):#line:62
    def __init__ (OO0O0O0OO000OOOOO ,mark :str =None ,*,count :int =None ,cycle :int =0 ,retry_exc :type or tuple =Exception ,):#line:71
        OO0O0O0OO000OOOOO .mark =mark #line:72
        OO0O0O0OO000OOOOO .count =count #line:73
        OO0O0O0OO000OOOOO .cycle =cycle #line:74
        OO0O0O0OO000OOOOO .retry_exc =retry_exc #line:75
    def core (OOOO0OOO0O000O000 ,O00O00OO000OOOOOO ,*OO0O000000O0OO00O ,**O0O0O00OOO00O0O0O ):#line:77
        OO000O0OO00OOOO00 =0 #line:78
        while True :#line:80
            try :#line:81
                return O00O00OO000OOOOOO (*OO0O000000O0OO00O ,**O0O0O00OOO00O0O0O )#line:82
            except OOOO0OOO0O000O000 .retry_exc as OOOO0OOO000O0O00O :#line:83
                try :#line:84
                    OO000O0OO00OOOO00 +=1 #line:85
                    OO0OO0O0OO0000O0O :str =OOOO0OOO0O000O000 .mark or i .hump (O00O00OO000OOOOOO .__name__ )#line:86
                    O0O000000O00OOOO0 :str =type (OOOO0OOO000O0O00O ).__name__ #line:87
                    ilog .simple .warning (f'[attempts:{OO000O0OO00OOOO00}/{OOOO0OOO0O000O000.count or "N"}] {OO0OO0O0OO0000O0O}.{O0O000000O00OOOO0}: {OOOO0OOO000O0O00O}')#line:89
                except Exception as O0OOOO0O00OO0000O :#line:90
                    ilog .simple .error (f'[{itime.Now.str}] RetryError: {O0OOOO0O00OO0000O}')#line:91
                if OOOO0OOO0O000O000 .count and OO000O0OO00OOOO00 ==OOOO0OOO0O000O000 .count :#line:93
                    raise OOOO0OOO000O0O00O #line:94
            time .sleep (OOOO0OOO0O000O000 .cycle )#line:96
class WhileTrue (BaseDecorator ):#line:99
    def __init__ (OOO00OO0O00O0OOOO ,cond =True ,*,cycle :int =0 ,precise :bool =False ,before :bool =False ):#line:108
        OOO00OO0O00O0OOOO .cond =cond #line:109
        OOO00OO0O00O0OOOO .cycle =cycle #line:110
        OOO00OO0O00O0OOOO .before =before #line:111
        OOO00OO0O00O0OOOO .core =OOO00OO0O00O0OOOO .precise if precise else OOO00OO0O00O0OOOO .conventional #line:112
    def core (OOOOO00OO0O0OOO00 ,OO0OO0OOO0O0OO0O0 ,*OOO0OO0OOO0O0O0OO ,**O0OOOOOOOOOOOOO00 ):#line:114
        pass #line:115
    def conventional (OOO0O0O0OO0O000O0 ,OO000000O0OO000O0 ,*OO000OOOOO00O000O ,**O0O0OOO000000000O ):#line:117
        while OOO0O0O0OO0O000O0 .cond :#line:118
            OOO0O0O0OO0O000O0 .before and time .sleep (OOO0O0O0OO0O000O0 .cycle )#line:119
            OOO0O0OO000O00OOO =OO000000O0OO000O0 (*OO000OOOOO00O000O ,**O0O0OOO000000000O )#line:120
            if OOO0O0OO000O00OOO =='_break_':#line:121
                break #line:122
            if OOO0O0OO000O00OOO =='_continue_':#line:123
                continue #line:124
            OOO0O0O0OO0O000O0 .before or time .sleep (OOO0O0O0OO0O000O0 .cycle )#line:125
    def precise (OO00OO00O0OOO00O0 ,OO0O0OO0OO0O00O00 ,*OO0O0OOO000O0OOO0 ,**OOOO000O00OOO0OOO ):#line:127
        O0OO0OOOOOO0O0O0O =OO00OO00O0OOO00O0 .cycle #line:128
        while OO00OO00O0OOO00O0 .cond :#line:129
            OO00OO00O0OOO00O0 .before and time .sleep (O0OO0OOOOOO0O0O0O )#line:130
            O00O00OOOO0O0O00O =time .time ()#line:131
            O00OO0O0OO0O0OOO0 =OO0O0OO0OO0O00O00 (*OO0O0OOO000O0OOO0 ,**OOOO000O00OOO0OOO )#line:132
            if O00OO0O0OO0O0OOO0 =='_break_':#line:133
                break #line:134
            if O00OO0O0OO0O0OOO0 =='_continue_':#line:135
                continue #line:136
            O0O0000O000OOOO00 =time .time ()#line:137
            O0OO0OOOOOO0O0O0O :float =abs (OO00OO00O0OOO00O0 .cycle -(O0O0000O000OOOO00 -O00O00OOOO0O0O00O ))#line:138
            OO00OO00O0OOO00O0 .before or time .sleep (O0OO0OOOOOO0O0O0O )#line:139
class RunTime (BaseDecorator ):#line:142
    def __init__ (O0O0OOO000O0O0O0O ,mark :str =None ):#line:144
        O0O0OOO000O0O0O0O .mark =mark #line:145
    def core (O0OO00OO0OO0OOO0O ,OOOOOO0O0OO0000O0 ,*O000O0O0O0000OOO0 ,**OOO0O0O000000O000 ):#line:147
        O0000O00O00O00000 =time .time ()#line:148
        OOOOOO0O0OO0000O0 (*O000O0O0O0000OOO0 ,**OOO0O0O000000O000 )#line:149
        OO00O0O0OOO0OOOOO =time .time ()#line:150
        O000000OO0OOOOOOO :str =O0OO00OO0OO0OOO0O .mark or i .hump (OOOOOO0O0OO0000O0 .__name__ )#line:152
        OOO0O0OO000OO000O :str =itime .second2time (OO00O0O0OOO0OOOOO -O0000O00O00O00000 )#line:153
        ilog .simple .info (f'{O000000OO0OOOOOOO}: {OOO0O0OO000OO000O}')#line:154
class TestFuncSpeed (BaseDecorator ):#line:157
    def __init__ (OO0O00OO0000O0O0O ,OOOO0OOO00O0O00OO :int ,*,keep :int =7 ):#line:159
        OO0O00OO0000O0O0O .count =OOOO0OOO00O0O00OO #line:160
        OO0O00OO0000O0O0O .keep =keep #line:161
    def core (O0O00OO00O0O0O000 ,OO0O00000OOOOOO0O ,*O0OOOOO0O00OO00OO ,**O000OO0O0O00O0OO0 ):#line:163
        O0OOOOOO0OO0O0O0O =[]#line:164
        for _O00O00OOO0O00O0O0 in range (O0O00OO00O0O0O000 .count ):#line:166
            OOO0OO000OO0OO0OO =time .time ()#line:167
            OO0O00000OOOOOO0O (*O0OOOOO0O00OO00OO ,**O000OO0O0O00O0OO0 )#line:168
            OO0000O00000OO000 =time .time ()#line:169
            O0OOOOOO0OO0O0O0O .append (OO0000O00000OO000 -OOO0OO000OO0OO0OO )#line:170
        for OO0O000O00OO0O000 in min ,max ,i .avg ,sum :#line:172
            O0OOO0O0O000OO00O =round (OO0O000O00OO0O000 (O0OOOOOO0OO0O0O0O ),O0O00OO00O0O0O000 .keep )#line:173
            print (f'{OO0O000O00OO0O000.__name__}: {O0OOO0O0O000OO00O}')#line:174
class BeforeFunc (BaseDecorator ):#line:177
    def __init__ (OOO0OOOOOOO000O00 ,O00OOO0OO0OOO00O0 ,*,enable :bool =True ):#line:179
        OOO0OOOOOOO000O00 .before_func =O00OOO0OO0OOO00O0 #line:180
        OOO0OOOOOOO000O00 .enable =enable #line:181
    def core (OO00O000OO0O00OOO ,OOOO000O0OOOO0OOO ,*O0OO0O0000O0000OO ,**OO0OO00OO0O0OOOO0 ):#line:183
        if not OO00O000OO0O00OOO .enable :#line:184
            return OOOO000O0OOOO0OOO (*O0OO0O0000O0000OO ,**OO0OO00OO0O0OOOO0 )#line:185
        try :#line:187
            OO0OOO0000O0O0OO0 =OO00O000OO0O00OOO .before_func (*O0OO0O0000O0000OO ,**OO0OO00OO0O0OOOO0 )#line:188
        except TypeError :#line:189
            OO0OOO0000O0O0OO0 =OO00O000OO0O00OOO .before_func ()#line:190
        if not isinstance (OO0OOO0000O0O0OO0 ,dict ):#line:192
            return OOOO000O0OOOO0OOO (*O0OO0O0000O0000OO ,**OO0OO00OO0O0OOOO0 )#line:193
        O0OO0O0000O0000OO :list =list (O0OO0O0000O0000OO )#line:195
        OOOOO000OO0O000O0 :tuple =OOOO000O0OOOO0OOO .__code__ .co_varnames #line:196
        if OOOOO000OO0O000O0 ==('a','kw'):#line:198
            OO0OO00OO0O0OOOO0 .update (OO0OOO0000O0O0OO0 )#line:199
            return OOOO000O0OOOO0OOO (*O0OO0O0000O0000OO ,**OO0OO00OO0O0OOOO0 )#line:200
        for O00OO00O00O00OO0O ,O0O0OO00OOO00O0O0 in enumerate (OOOOO000OO0O000O0 ):#line:202
            if O0O0OO00OOO00O0O0 in OO0OOO0000O0O0OO0 :#line:203
                try :#line:204
                    O0OO0O0000O0000OO [O00OO00O00O00OO0O ]=OO0OOO0000O0O0OO0 [O0O0OO00OOO00O0O0 ]#line:205
                except IndexError :#line:206
                    OO0OO00OO0O0OOOO0 [O0O0OO00OOO00O0O0 ]=OO0OOO0000O0O0OO0 [O0O0OO00OOO00O0O0 ]#line:207
        return OOOO000O0OOOO0OOO (*O0OO0O0000O0000OO ,**OO0OO00OO0O0OOOO0 )#line:209
class AfterFunc (BaseDecorator ):#line:212
    def __init__ (OO00O0OO0OO0OOO00 ,O0000OOO0OOOOOOO0 ,*,use_raw_params :bool =False ,enable :bool =True ):#line:220
        OO00O0OO0OO0OOO00 .after_func =O0000OOO0OOOOOOO0 #line:221
        OO00O0OO0OO0OOO00 .use_raw_params =use_raw_params #line:222
        OO00O0OO0OO0OOO00 .enable =enable #line:223
    def core (O0000O00OOO00OOO0 ,OOO000O0O0O0OO00O ,*OO00000OOO00OOO00 ,**O000OO0O0OOOO0O0O ):#line:225
        OOOO0OO00O0OOO00O =OOO000O0O0O0OO00O (*OO00000OOO00OOO00 ,**O000OO0O0OOOO0O0O )#line:226
        if not O0000O00OOO00OOO0 .enable :#line:228
            return OOOO0OO00O0OOO00O #line:229
        if isinstance (O0000O00OOO00OOO0 .after_func ,ibase .FuncMode ):#line:231
            OOOO0O0OO0O00OO00 :tuple =O0000O00OOO00OOO0 .after_func .__init__ .__code__ .co_argcount #line:232
        else :#line:233
            OOOO0O0OO0O00OO00 :tuple =O0000O00OOO00OOO0 .after_func .__code__ .co_argcount #line:234
        if OOOO0O0OO0O00OO00 ==0 :#line:236
            OOOO0O0O0000000OO =O0000O00OOO00OOO0 .after_func ()#line:237
        elif O0000O00OOO00OOO0 .use_raw_params :#line:238
            OOOO0O0O0000000OO =O0000O00OOO00OOO0 .after_func (*OO00000OOO00OOO00 ,**O000OO0O0OOOO0O0O )#line:239
        else :#line:240
            try :#line:241
                OOOO0O0O0000000OO =O0000O00OOO00OOO0 .after_func (OO00000OOO00OOO00 [0 ],*OOOO0OO00O0OOO00O if isinstance (OOOO0OO00O0OOO00O ,tuple )else OOOO0OO00O0OOO00O )#line:243
            except (IndexError ,TypeError ):#line:244
                OOOO0O0O0000000OO =O0000O00OOO00OOO0 .after_func (*OOOO0OO00O0OOO00O if isinstance (OOOO0OO00O0OOO00O ,tuple )else OOOO0OO00O0OOO00O )#line:246
        return OOOO0OO00O0OOO00O if OOOO0O0O0000000OO is None else OOOO0O0O0000000OO #line:248
